var $jQ = jQuery.noConflict();
$jQ(document).ready(function(){
    var bodyHeight = $jQ(document).height();
    var adminmenu_height = $jQ('#adminmenuwrap').height();
    if(bodyHeight > adminmenu_height){
        $jQ("#datamain").height(bodyHeight);
    }
    else
    {
        $jQ("#datamain").height(adminmenu_height);
    }
    var normal_attributes = [];
    var category_attributes = [];
    function isValidEmailAddress(emailAddress) {
        var pattern = new RegExp(/^([\w-\.]+@([\w-]+\.)+[\w-]{2,4})?$/);
        return pattern.test(emailAddress);
    }
    function change_field_attr(){
        var attr_val = $jQ('#cssel_attribute').val();
        var attr_type, attr_name, attr_text;
        if (attr_val == 'email' || attr_val == 'submit') {
            // get all info of attr
            var hidden_attr = $jQ('#cshidden_' + attr_val);
            attr_type = hidden_attr.attr('data-type');
            attr_name = hidden_attr.attr('data-name');
            attr_text = hidden_attr.attr('data-text');
        }
        else {
            $jQ.each(normal_attributes, function(index, value) {
                if (value['Name'] == attr_val) {
                    attr_type = value['DataType'];
                    attr_name = value['Name'];
                    attr_text = value['Label'];
                }
            });
            $jQ.each(category_attributes, function(index, value) {
                if (value['name'] == attr_val) {
                    attr_type = value['type'];
                    attr_name = value['name'];
                    attr_text = attr_name;
                }
            });
        }
        // generate attribute html
        generate_attribute_html(attr_type, attr_name, attr_text);
    }
    function change_attribute_tag(attr_type, attr_name, attr_text,attr_value){
        $jQ('#csfield_label').attr('value', attr_text);
        $jQ('#csfield_placeholder').attr('value', '');
        $jQ('#csfield_initial').attr('value', attr_value);
        $jQ('#csfield_button_text').attr('value', attr_text);
        $jQ('.cs-attr-other').hide();
        $jQ('.cs-attr-normal').hide();
        $jQ('.cs-attr-category').hide();
        $jQ('#csfield_required').removeAttr('checked');
        var dateformat = $jQ('.cs-dateformat').val();
        switch(attr_type.toLowerCase())
        {
            case 'email':
                $jQ('#csfield_required').attr('checked', 'true');
                dateformat = '';
            case 'date':
                $jQ('#csfield_placeholder').val(dateformat);
            case 'picklist':
            case 'picklistmultiselect':
            case 'text':
            case 'textarea':
            case 'textarealong':
            case 'datetime':
            case 'checkbox':
            case 'lookuprelationship':
            case 'number':
            case 'float':
                $jQ('.cs-attr-normal').show();
                if(attr_name == 'SMS'){
                    $jQ('#csfield_initial_area').hide();
                }
                break;
            case 'category':
                $jQ('.cs-attr-category').show();
                break;
            case 'submit':
                $jQ('.cs-attr-other').show();
                break;
            default:
                $jQ('.cs-attr-normal').show();
                break;
        }
    }
    // generate attribute html
    function generate_attribute_html(attr_type, attr_name, attr_text){
        var field_label = $jQ('#csfield_label').val();
        var field_placeholder = $jQ('#csfield_placeholder').val();
        var field_initial = $jQ('#csfield_initial').val();
        var field_buttontext = $jQ('#csfield_button_text').val();
        //var field_wrap = $jQ('#csfield_wrap').is(':checked');
        var field_required = $jQ('#csfield_required').is(':checked');
        if(field_required == true) field_label += '*';
        var field_type = $jQ('input[name=csfield_type]:checked').val();
        var dateformat = $jQ('.cs-dateformat').val();
        var field_html = '';
        if(attr_type != 'submit') {
            field_html += '<p class="cs-' + attr_name + '-area"> \n';
        }
        else {
            field_html += '<p> \n';
        }
        if ((field_label != '') && (attr_type == 'category')) {
            if (field_type == 'select') {
                field_html += '    <label class="cs-' + attr_name + '-area">' + field_label + '</label> \n';
            }
            else {
                field_html += '    <div style="display:block;"><label class="cs-' + attr_name + '-area">' + field_label + '</label></div> \n';
            }
        }
        else if((field_label != '') && (attr_type != 'submit')) {
            field_html += '    <label class="cs-' + attr_name + '-area">' + field_label + '</label> \n';
        }
        switch (attr_type.toLowerCase())
        {
            case 'email':
                field_html += '    <input type="email" class="cs-' + attr_name + '-area" name="' + attr_name + '"  ';
                field_html += 'placeholder="' + field_placeholder + '" ';
                field_html += 'value="' + field_initial + '" ';
                if(field_required == true) {
                    field_html += 'required="required" ';
                }
                field_html += '> \n';
                break;
            case 'date':
                dateformat = 'dd-mm-yyyy';
                field_html += '    <input type="date" class="cs-' + attr_name + '-area cs-date" data-format="' + dateformat + '" name="' + attr_name + '" ';
                field_html += 'placeholder="' + field_placeholder + '" ';
                field_html += 'value="' + field_initial + '" ';
                if(field_required == true) {
                    field_html += 'required="required" ';
                }
                field_html += '> \n';
                break;
            case 'datetime':
                dateformat = 'dd-mm-yyyy hh:mm';
                field_html += '    <input type="datetime-local" class="cs-' + attr_name + '-area" data-format="' + dateformat + '" name="' + attr_name + '" ';
                field_html += 'placeholder="' + field_placeholder + '" ';
                field_html += 'value="' + field_initial + '" ';
                if(field_required == true) {
                    field_html += 'required="required" ';
                }
                field_html += '> \n';
                break;
            case 'checkbox':
                field_html += '    <input type="checkbox" class="cs-' + attr_name + '-area" name="' + attr_name + '" ';
                field_html += 'placeholder="' + field_placeholder + '" ';
                field_html += 'value="' + field_initial + '" ';
                if(field_required == true) {
                    field_html += 'required="required" ';
                }
                field_html += '> \n';
                break;
            case 'picklist':
                var PicklistValues = []
                $jQ.each(normal_attributes, function(index, value) {
                    if (value['Name'] == attr_name) {
                        PicklistValues = value['PicklistValues'];
                    }
                });
                field_html += '    <select class="cs-' + attr_name + '-area" name="' + attr_name + '" ';
                if(field_required == true) {
                    field_html += 'required="required" ';
                }
                field_html += '> \n ';
                var sel = ""
                $jQ.each(PicklistValues, function(index, value) {
                    if (value['IsActive']) {
                        if(value['IsDefault'] || field_initial==value['Name']){ sel = "selected='selected'"}else{sel = ''}
                    field_html += '<option value="'+value['Name']+'" '+sel+'>'+value['Label']+'</option> \n ';
                    }
                });
                field_html += '</select> \n';
                break;
             case 'picklistmultiselect':
                var PicklistMultiSelectValues = []
                $jQ.each(normal_attributes, function(index, value) {
                    if (value['Name'] == attr_name) {
                        PicklistMultiSelectValues = value['PicklistValues'];
                    }
                });
                field_html += '    <select class="cs-' + attr_name + '-area" name="' + attr_name + '[]"  multiple';
                if(field_required == true) {
                    field_html += 'required="required" ';
                }
                field_html += '> \n ';
                var sel = ""
                $jQ.each(PicklistMultiSelectValues, function(index, value) {
                    if (value['IsActive']) {
                        if(value['IsDefault'] || field_initial==value['Name']){ sel = "selected='selected'"}else{sel = ''}
                    field_html += '<option value="'+value['Name']+'" '+sel+'>'+value['Label']+'</option> \n ';
                    }
                });
                field_html += '</select> \n';
                break;    
            case 'lookuprelationship':
                field_html += '    <input type="search" class="cs-' + attr_name + '-area" name="' + attr_name + '" ';
                field_html += 'placeholder="' + field_placeholder + '" ';
                field_html += 'value="' + field_initial + '" ';
                if(field_required == true) {
                    field_html += 'required="required" ';
                }
                field_html += '> \n';
                break;
            case 'textarea':
                field_html += '    <textarea class="cs-' + attr_name + '-area" name="' + attr_name + '" ';
                field_html += 'placeholder="' + field_placeholder + '" ';
                field_html += 'value="' + field_initial + '" ';
                if(field_required == true) {
                    field_html += 'required="required" ';
                }
                field_html += '></textarea> \n';
                break;
            case 'textarealong':
                field_html += '    <textarea class="cs-' + attr_name + '-area" name="' + attr_name + '" ';
                field_html += 'placeholder="' + field_placeholder + '" ';
                field_html += 'value="' + field_initial + '" ';
                if(field_required == true) {
                    field_html += 'required="required" ';
                }
                field_html += '></textarea> \n';
                break;
            case 'text':
                if ( attr_name == "SMS" ) {
                    field_html += '<div class="cs-sms-field"><div class="cs-country-block">' +
                        '<div class="cs-toggle cs-country-flg"><div class="cs-cflags"></div> ' +
                        '<div class="cs-icon-arrow"></div></div> '+
                        '</div>' + '<ul class="cs-country-list" style="display: none;"></ul>' +
                        '<input type="hidden" name="csSMS_prefix" value="+33"><input type="text" name="SMS" class="cs-sms" value="+33" ';
                    if(field_placeholder != '') {
                        field_html += 'placeholder="' + field_placeholder + '" ';
                    }
                    if(field_required == true) {
                        field_html += 'required="required" ';
                    }
                    field_html += '></div>\n';
                }
                else {
                    field_html += '    <input type="text" class="cs-' + attr_name + '-area" name="' + attr_name + '" ';
                    if(field_placeholder != '') {
                        field_html += 'placeholder="' + field_placeholder + '" ';
                    }
                    if(field_initial != '') {
                        field_html += 'value="' + field_initial + '" ';
                    }
                    if(field_required == true) {
                        field_html += 'required="required" ';
                    }
                    field_html += '> \n';
                }
                break;
            case 'phone':
                field_html += '    <input type="tel" class="cs-' + attr_name + '-area" name="' + attr_name + '" ';
                if(field_placeholder != '') {
                    field_html += 'placeholder="' + field_placeholder + '" ';
                }
                if(field_initial != '') {
                    field_html += 'value="' + field_initial + '" ';
                }
                if(field_required == true) {
                    field_html += 'required="required" ';
                }
                field_html += '> \n';
                break;
            case 'float':
                field_html += '    <input type="text" class="cs-' + attr_name + '-area" name="' + attr_name + '"  ';
                if(field_placeholder != '') {
                    field_html += 'placeholder="' + field_placeholder + '" ';
                }
                if(field_initial != '') {
                    field_html += 'value="' + field_initial + '" ';
                }
                if(field_required == true) {
                    field_html += 'required="required" ';
                }
                field_html += 'pattern="[0-9]+([\\.|,][0-9]+)?" > \n';
                break;
            case 'submit':
                field_html += '    <input type="submit" class="cs-default-btn" name="' + attr_name + '" ';
                field_html += 'value="' + field_buttontext + '" ';
                field_html += '> \n';
                break;
            case 'category':
                var enumeration = [];
                $jQ.each(category_attributes, function(index, value) {
                    if (value['name'] == attr_name) {
                        enumeration = value['enumeration'];
                    }
                });
                if (field_type == 'select') {
                    field_html += '    <select class="cs-' + attr_name + '-area" name="' + attr_name + '" ';
                    if (field_required == true) {
                        field_html += 'required="required" ';
                    }
                    field_html += '> \n';
                }
                $jQ.each(enumeration, function(index, value) {
                    if (field_type == 'select') {
                        field_html += '      <option value="' + value['value'] + '">' + value['label'] + '</option> \n';
                    }
                    else {
                        field_html += '    <div style="display:block;"><input type="radio" class="cs-' + attr_name + '-area" name="' + attr_name + '" value="' + value['value'] + '" ';
                        if (field_required == true) {
                            field_html += 'required="required" ';
                        }
                        field_html += '>' + value['label'] + '</div> \n';
                    }
                });
                if (field_type == 'select') {
                    field_html += '    </select> \n';
                }
                break;
            default:
                field_html += '    <input type="'+attr_type.toLowerCase()+'" class="cs-' + attr_name + '-area" name="' + attr_name + '" placeholder="' + field_placeholder + '">';
                break;
        }
        field_html += '</p>';
        $jQ('#csfield_html').html(field_html);
    }
    function set_select_list() {
        var selected_list_id = $jQ('#csselected_list_id').val();
        var data = {
            frmid : $jQ('input[name=csform_id]').val(),
            action : 'csget_lists',
            security: ajax_csobject.ajax_nonce
        };
        $jQ.post(ajax_csobject.ajax_url, data, function(respond) {
            var select_html = '';
            var selected = respond.selected;
            $jQ.each(respond.lists, function(index, value) {
                if(value['name'] == 'Temp - DOUBLE OPTIN') return true;
                if ( selected.indexOf(value['id'].toString()) != '-1' ) {
                    select_html += '<option value="' + value['id'] + '" selected>' + value['name'] + '</option>';
                }
                else {
                    select_html += '<option value="' + value['id'] + '">' + value['name'] + '</option>';
                }
            });
            $jQ('#csselect_list').html(select_html).trigger("chosen:updated");
            set_select_attributes();
        });
    }
    function set_select_template() {
        var selected_template_id = $jQ('#csselected_template_id').val();
        var selected_do_template_id = $jQ('#csselected_do_template_id').val();
        var selected_confirm_template_id = $jQ('#csselected_confirm_template_id').val();
        var default_template_name = $jQ('#csdefault_template_name').val();
        var data = {
            action : 'csget_templates',
            security: ajax_csobject.ajax_nonce
        };
        $jQ.post(ajax_csobject.ajax_url, data, function(respond) {
            var select_html = '<select id="cstemplate_id" class="col-md-11" name="template_id">';
            if (selected_template_id == '-1') {
                select_html += '<option value="-1" selected>' + default_template_name + '</option>';
            }
            else {
                select_html += '<option value="-1">' + default_template_name + '</option>';
            }
            $jQ.each(respond.templates, function(index, value) {
                if (value['id'] == selected_template_id) {
                    select_html += '<option value="' + value['id'] + '" selected>' + value['name'] + '</option>';
                }
                else {
                    select_html += '<option value="' + value['id'] + '">' + value['name'] + '</option>';
                }
            });
            select_html += '</select>';
            $jQ('#cstemplate_id_area').html(select_html);
            // For double optin.
            select_html = '<select class="col-md-11" name="doubleoptin_template_id" id="csdoubleoptin_template_id">';
            if (selected_do_template_id == '-1') {
                select_html += '<option value="-1" selected>' + default_template_name + '</option>';
            }
            else {
                select_html += '<option value="-1">' + default_template_name + '</option>';
            }
            $jQ.each(respond.templates, function(index, value) {
                if (value['id'] == selected_do_template_id) {
                    select_html += '<option is_shortcode="' + value['is_dopt']  + '" value="' + value['id'] + '" selected>' + value['name'] + '</option>';
                }
                else {
                    select_html += '<option is_shortcode="' + value['is_dopt']  + '" value="' + value['id'] + '">' + value['name'] + '</option>';
                }
            });
            select_html += '</select>';
            //$jQ('#csdoubleoptin_template_id_area').html(select_html);
            // For final confirmation emait template
            select_html = '<select id="csconfirm_template_id" class="col-md-11" name="confirm_template_id">';
            if (selected_confirm_template_id == '-1') {
                select_html += '<option value="-1" selected>' + default_template_name + '</option>';
            }
            else {
                select_html += '<option value="-1">' + default_template_name + '</option>';
            }
            $jQ.each(respond.templates, function(index, value) {
                if (value['id'] == selected_confirm_template_id) {
                    select_html += '<option is_shortcode="' + value['is_dopt']  + '" value="' + value['id'] + '" selected>' + value['name'] + '</option>';
                }
                else {
                    select_html += '<option is_shortcode="' + value['is_dopt']  + '" value="' + value['id'] + '">' + value['name'] + '</option>';
                }
            });
            select_html += '</select>';
            $jQ('#csfinal_confirm_template_id_area').html(select_html);
            // double optin template id
            $jQ('#csdoubleoptin_template_id').on('change', function() {
                var shortcode_exist = $jQ(this).find(':selected').attr('is_shortcode');
                if (shortcode_exist == 0 && $jQ(this).val() != -1) {
                    $jQ('#csform_alert_message').show();
                    $jQ('#csdisclaim_smtp').hide();
                    $jQ('#csdisclaim_confirm_template').hide();
                    $jQ('#csdisclaim_do_template').show();
                    $jQ(this).val('-1');
                }
                else {
                    $jQ('#csform_alert_message').hide();
                }
            });
            // Final confirm template id
            $jQ('#csconfirm_template_id').on('change', function() {
                var shortcode_exist = $jQ(this).find(':selected').attr('is_shortcode');
                if (shortcode_exist == 1 && $jQ(this).val() != -1) {
                    $jQ('#csform_alert_message').show();
                    $jQ('#csdisclaim_smtp').hide();
                    $jQ('#csdisclaim_confirm_template').show();
                    $jQ('#csdisclaim_do_template').hide();
                    $jQ(this).val('-1');
                }
                else {
                    $jQ('#csform_alert_message').hide();
                }
            });
            $jQ('#cssetting_signup_spin').addClass('hide');
        });
    }
    function set_select_attributes() {
        var data = {
            action : 'csget_attributes',
            moduleID : $jQ('input[name=moduleID]').val(),
            security: ajax_csobject.ajax_nonce
        };
        var DoptinDThtml  = ''; 
        $jQ.post(ajax_csobject.ajax_url, data, function(respond) {
            var iframWidth = $jQ('.form-field').width() - 48;
            $jQ('#cs-preview-form').width(iframWidth);
            normal_attributes = respond.attrs.attributes.normal_attributes;
            //console.log(JSON.stringify(normal_attributes));
            category_attributes = respond.attrs.attributes.category_attributes;
            var attr_email_name = $jQ('#cshidden_email').attr('data-text');
            var message_1 = $jQ('#cshidden_message_1').val();
            var message_2 = $jQ('#cshidden_message_2').val();
            var message_3 = $jQ('#cshidden_message_3').val();
            var message_4 = $jQ('#cshidden_message_4').val();
            var message_5 = $jQ('#cshidden_message_5').val();
            var select_html = '<select class="col-md-12" id="cssel_attribute">' +
                '<option value="-1" disabled selected>' + message_1 + '</option>' +
                '<optgroup label="' + message_2 + '">';
//            select_html += '<option value="email">' + attr_email_name + '*</option>';
            $jQ.each(normal_attributes, function(index, value) {
              /***** Double Opt-in DateTime Field  "DataType":"DateTime" *****/  
               if(value['DataType']=='DateTime' && value['IsEditable']==true){
                    if($jQ('#is_datetime_double_optin').attr('datetimeDopt')==value['Name']){
                        dtdopintselc =  'selected="selected"';
                    }else{
                        dtdopintselc =  '';
                    }
                  DoptinDThtml += '<option value="' + value['Name'] + '" '+dtdopintselc+' >' + value['Label'] +'</option>';  
               }
                if(value['IsEditable']==true){  // Hide field IsEditable=false
                   // System field off
                  if(value['IsFormula'] == true){ return true;}
                  if(value['DataType']  =='RollUpSummary' || value['DataType'] =='AutoNumber' || value['DataType'] == 'LookupRelationship' || value['DataType'] == 'LookupMultiRelationships'){ return true;}
                 if(value['Name']!='OwnerId'){  // OwnerId disable
                    select_html += '<option value="' + value['Name'] + '">' + value['Label'] +'</option>';
                 }
              }
            });
            select_html += '</optgroup>';
            select_html += '<optgroup label="' + message_3 + '">';
            $jQ.each(category_attributes, function(index, value) {
                if(value['name'] == 'DOUBLE_OPT-IN') return;
                select_html += '<option value="' + value['name'] + '">' + value['name'] + '</option>';
            });
            select_html += '</optgroup>';
            select_html += '<optgroup label="' + message_4 + '">';
            select_html += '<option value="submit">' + message_5 + '</option>';
            select_html += '</optgroup>';
            select_html += '</select>';
            if(DoptinDThtml==""){
             $jQ('#is_datetime_double_optin').hide();
            }else{
              $jQ('#is_datetime_double_optin').html(DoptinDThtml).show();  
            }
            $jQ('#cssel_attribute_area').html(select_html);
            $jQ('#cssel_attribute').on('change', function() {
                //
                $jQ('#cs-field-content').show();
                var attr_val = $jQ(this).val();
                var attr_type, attr_name, attr_text;
                if (attr_val == 'email' || attr_val == 'submit') {
                    // get all info of attr
                    var hidden_attr = $jQ('#cshidden_' + attr_val);
                    attr_type = hidden_attr.attr('data-type');
                    attr_name = hidden_attr.attr('data-name');
                    attr_text = hidden_attr.attr('data-text');
                }
                else {
                    $jQ.each(normal_attributes, function(index, value) {
                        if (value['Name'] == attr_val) {
                            attr_type  = value['DataType'];
                            attr_name  = value['Name'];
                            attr_text  = value['Label'];
                            if(attr_type=="Checkbox"){
                               attr_value= '1';
                            }else{
                              attr_value = value['DefaultValue'];
                            }
                        }
                    });
                    $jQ.each(category_attributes, function(index, value) {
                        if (value['name'] == attr_val) {
                            attr_type = value['type'];
                            attr_name = value['name'];
                            attr_text = attr_name;
                        }
                    });
                }
                // change attribute tags
                change_attribute_tag(attr_type, attr_name, attr_text,attr_value);
                // generate attribute html
                generate_attribute_html(attr_type, attr_name, attr_text);
            });
            $jQ('#cssetting_form_spin').addClass('hide');
            set_select_template();
        });
    }
    function update_preview(){
        var frmid = $jQ('#csform_id').val();
        var formHtml = $jQ('#sibformmarkup').val();
        var formCss = $jQ('#sibcssmarkup').val();
        var isDepend = $jQ('input[name=cscss_type]:checked').val();
        var gCaptcha = $jQ('input[name=csadd_captcha]:checked').val();
        var gCaptchaType = $jQ('input[name=csrecaptcha_type]:checked').val();
        var gCaptchaSite = $jQ('#cscaptcha_site').val();
        var data = {
            action:'csupdate_form_html',
            security: ajax_csobject.ajax_nonce,
            frmid: frmid,
            frmData: formHtml,
            frmCss: formCss,
            isDepend: isDepend,
            gCaptcha: gCaptcha,
            gCaptchaType: gCaptchaType,
            gCaptchaSite: gCaptchaSite
        };
        $jQ.post(ajax_csobject.ajax_url, data,function() {
            var preview_form = $jQ('#cs-preview-form');
            preview_form.attr('src', preview_form.attr('src') + '&action=update');
        });
    }
    // get cursor posistion of text area
    function get_cursor_position(node) {
        //node.focus();
        /* without node.focus() IE will returns -1 when focus is not on node */
        if(node.selectionStart) return node.selectionStart;
        else if(!document.selection) return 0;
        var c		= "\001";
        var sel	= document.selection.createRange();
        var dul	= sel.duplicate();
        dul.moveToElementText(node);
        sel.text	= c;
        var len		= (dul.text.indexOf(c));
        sel.moveStart('character',-1);
        sel.text	= "";
        return len;
    }
    // set cursor position at top of text area
    function setSelectionRange(input, selectionStart, selectionEnd) {
        if (input.setSelectionRange) {
            input.focus();
            input.setSelectionRange(selectionStart, selectionEnd);
        } else if (input.createTextRange) {
            var range = input.createTextRange();
            range.collapse(true);
            range.moveEnd('character', selectionEnd);
            range.moveStart('character', selectionStart);
            range.select();
        }
    }
    // generate html for multi subscription lists
    function generate_multi_list_html() {
        var field_label = $jQ('#csmulti_field_label').val();
        var field_html = '<p class="cs-multi-lists-area">\n';
        var list_id = '';
        var list_name = '';
        var required = false;
        var required_label = '';
        var required_attr = '';
        if ( $jQ('#csmulti_field_required').is(":checked"))
        {
            required = true;
            required_label = '*';
            required_attr = 'required';
        }
        if ( field_label != '' )
        {
            field_html += '<label>' + field_label + required_label + '</label>\n';
        }
        field_html += '<div class="cs-multi-lists" data-require="' + required_attr + '">\n';
        var selected_lists = $jQ('#csselect_multi_list').find('option:selected', this);
        selected_lists.each(function(){
            list_id = $jQ(this).val();
            list_name = $jQ(this).data('list');
            field_html += '<div style="block"><input type="checkbox" class="cs-interesting-lists" value="' + list_id + '" name="listIDs[]">' + list_name + '</div>\n';
        });
        field_html += '</div></p>';
        $jQ('#csmulti_field_html').html(field_html);
    }
    /////////////////////////////////
    /*       home settings         */
    /////////////////////////////////
    // var elements
    var csusername = $jQ('#csusername');
    var cspassword = $jQ('#cspassword');
    var csvalidate_btn = $jQ('#csvalidate_btn');
    // validate button click process in welcome page
    csvalidate_btn.on('click', function(){
        var username = csusername.val();
        var password = cspassword.val();
        // check validation
        var error_flag = 0;
        if(username == '') {
            csusername.addClass('error');
            error_flag =1;
        }
        if(password == '') {
            cspassword.addClass('error');
            error_flag =1;
        }
        if(error_flag != 0) {
            return false;
        }
        // ajax process for validate
        var data = {
            action:'csvalidate_process',
            username: username,
            password: password,
            security: ajax_csobject.ajax_nonce
        };
        $jQ('.csalert').hide();
        $jQ('.cs-spin').show();
        csusername.removeClass('error');
        cspassword.removeClass('error');
        $jQ(this).attr('disabled', 'true');
        $jQ.post(ajax_csobject.ajax_url, data, function(respond) {
            $jQ('.cs-spin').hide();
            csvalidate_btn.removeAttr('disabled');
            if(respond == 'success') {
                $jQ('#success-alert').show();
                var cur_url = $jQ('#cur_refer_url').val();
                window.location.href = cur_url;
                //window.location.reload();
            }
            else if (respond == 'curl_no_installed') {
                csusername.addClass('error');
                cspassword.addClass('error');
                $jQ('#failure-alert').html($jQ('#curl_no_exist_error').val()).show();
            }
            else if (respond == 'curl_error') {
                csusername.addClass('error');
                cspassword.addClass('error');
                $jQ('#failure-alert').html($jQ('#curl_error').val()).show();
            }           
            else {
                csusername.addClass('error');
                cspassword.addClass('error');
                //$jQ('#failure-alert').text(respond).show(); // This displays the full response body - used for debugging
                $jQ('#failure-alert').html($jQ('#general_error').val()).show();
            }
        });
    });
    csusername.on('keypress', function(){
        $jQ(this).removeClass('error');
    });
    cspassword.on('keypress', function(){
        $jQ(this).removeClass('error');
    });
    // Transactional emails
    $jQ('input[name=activate_email]').on('click', function(){
        var option_val = $jQ(this).val();
        var data = {
            action: 'csactivate_email_change',
            option_val: option_val,
            security: ajax_csobject.ajax_nonce
        };
        $jQ.post(ajax_csobject.ajax_url, data, function(respond) {
            if(respond == 'yes')
                $jQ('#email_send_field').show();
            else
                $jQ('#email_send_field').hide();
        });
        return true;
    });
    // change sender detail
    $jQ('#sender_list').on('change',function(){
        var data = {
            action: 'cssender_change',
            sender: $jQ(this).val(),
            security: ajax_csobject.ajax_nonce
        };
        $jQ.post(ajax_csobject.ajax_url, data, function() {
            $jQ(this).blur();
        });
        return true;
    });
    // validate MA
    $jQ('#validate_ma_btn').on('click',function(){
        var option_val = $jQ('input[name=activate_ma]:checked').val();
        var data = {
            action:'csvalidate_ma',
            option_val: option_val,
            security: ajax_csobject.ajax_nonce
        };
        var uninstall = false;
        var uninstallMsg = $jQ('#cs-ma-unistall').val();
        if(option_val != 'yes'){
            uninstall = confirm(uninstallMsg);
        }
        if(option_val == 'yes' || uninstall) {
            $jQ(this).find('.cs-spin').show();
            $jQ('.cs-ma-alert').hide();
            $jQ(this).attr('disabled', 'true');
            $jQ.post(ajax_csobject.ajax_url, data, function (respond) {
                $jQ('.cs-spin').hide();
                $jQ('#validate_ma_btn').removeAttr('disabled');
                if (respond == 'yes') {
                    $jQ('.cs-ma-active').show();
                } else if(respond == 'no') {
                    $jQ('.cs-ma-inactive').show();
                } else if(respond == 'disabled'){
                    $jQ('.cs-ma-disabled').show();
                    $jQ('#activate_ma_radio_no').prop('checked', true);
                }
                setTimeout(function(){
                    if(respond != 'disabled')
                        window.location.reload();
                },2000);
            });
        }
    });
    // send activate email button
    $jQ('#send_email_btn').on('click',function(){
        var activate_email = $jQ('#activate_email');
        var email = activate_email.val();
        if(email == '' || isValidEmailAddress(email) != true) {
            activate_email.removeClass('has-success').addClass('error');
            $jQ('#failure-alert').show();
            return false;
        }
        $jQ(this).attr('disabled', 'true');
        var data = {
            action:'cssend_email',
            email:email,
            security: ajax_csobject.ajax_nonce
        };
        $jQ('.csalert').hide();
        activate_email.removeClass('error');
        $jQ(this).find('.cs-spin').show();
        $jQ.post(ajax_csobject.ajax_url, data,function(respond) {
            $jQ('.cs-spin').hide();
            $jQ('#send_email_btn').removeAttr('disabled');
            if(respond != 'success') {
                $jQ('#activate_email').removeClass('has-success').addClass('error');
                $jQ('#failure-alert').show();
            } else {
                $jQ('#success-alert').show();
            }
        });
    });
    ////////////////////////////////
    /*       manage forms         */
    ////////////////////////////////
    $jQ('#cs-field-content').hide();
    // check confirm email
    var is_send_confirm_email = $jQ("input[name=is_confirm_email]:checked").val();
    if(is_send_confirm_email == '1') {
        $jQ('#csconfirm_template_area').show();
        $jQ('#csconfirm_sender_area').show();
    } else {
        $jQ('#csconfirm_template_area').hide();
        $jQ('#csconfirm_sender_area').hide();
    }
    // check double optin
    var is_double_optin = $jQ("input[name=is_double_optin]:checked").val();
    if(is_double_optin == '1') {
         var selectOption = '';
            $jQ($jQ("#sibformmarkup").val()).find("input[type='email']").each(function(index,i){
                selectOption +='<option value="'+$jQ(this).attr('name')+'">'+$jQ(this).parent().children(':first').html()+'</option>'
             });
        $jQ('#is_email_double_optin').html(selectOption).show(); 
        $jQ("#is_email_double_optin option[value='"+$jQ('#is_email_double_optin').attr('emailDopt')+"']").attr('selected', 'selected');
        $jQ('#is_email_double_optin').show();
        $jQ('#is_confirm_email_no').prop("checked", true);
        $jQ('#csconfirm_template_area').hide();
        $jQ('#csconfirm_sender_area').hide();
        $jQ('#csdouble_sender_area').show();
        $jQ('#csdoubleoptin_template_area').show();
    } else {
        $jQ('#is_email_double_optin').hide();
        $jQ('#csdouble_sender_area').hide();
        $jQ('#csdouble_redirect_area').hide();
        $jQ('#csdoubleoptin_template_area').hide();
        $jQ('#csfinal_confirm_template_area').hide();
    }
    if ($jQ('#cssetting_signup_body').find('#csselect_list_area').length > 0 ) {
        set_select_list();
        $jQ('#csselect_list').chosen({width:"100%"});
    }
    // For multi lists subscription
    if ( $jQ('#cssetting_form_body').find('#cssel_multi_list_area').length > 0 ) {
        var data = {
            frmid : $jQ('input[name=csform_id]').val(),
            action : 'csget_lists',
            security: ajax_csobject.ajax_nonce
        };
        $jQ.post(ajax_csobject.ajax_url, data, function(respond) {
            var select_html = '';
            $jQ.each(respond.lists, function(index, value) {
                if(value['name'] == 'Temp - DOUBLE OPTIN') return true;
                select_html += '<option value="' + value['id'] + '" data-list="' + value['name'] + '">' + value['name'] + '</option>';
            });
            $jQ('#csselect_multi_list').html(select_html).trigger("chosen:updated");
            $jQ('#csselect_multi_list').chosen({width:"100%"});
        });
    }
    $jQ('#csselect_multi_list').on('change', function(){
       if ( $jQ(this).val() != null )
       {
           $jQ('#csmulti_list_field').show();
           generate_multi_list_html();
       }
       else {
           $jQ('#csmulti_list_field').hide();
       }
    });
    $jQ('#csmulti_field_label').on('change', function () {
        generate_multi_list_html();
    });
    $jQ('#csmulti_field_required').on('change', function () {
       generate_multi_list_html();
    });
    // keep change of fields
    $jQ('.csfield_changes').on('change',function() {
        change_field_attr();
    });
    // click yes form data to specific emails
    $jQ('#is_data_emails_specific_click_yes').on('click', function () {
        $jQ('#cssubscrition_emails_specific_area').show();
    });
    $jQ('#is_data_emails_specific_click_no').on('click', function () {
        $jQ('#cssubscrition_emails_specific_area').hide();
    });
    // click confirm email
    $jQ("input[name=is_confirm_email]").on('click',function() {
        var confirm_email = $jQ(this).val();
        var is_activated_smtp = parseInt($jQ("#is_smtp_activated").val());
        if(confirm_email == '1') {
            $jQ('#csdoubleoptin_template_id').val('-1');
            $jQ('#csconfirm_template_id').val('-1');
            $jQ('#is_double_optin_no').prop("checked", true);
            $jQ('#csdouble_sender_area').hide();
            $jQ('#csdouble_redirect_area').hide();
            $jQ('#csconfirm_template_area').show();
            $jQ('#csconfirm_sender_area').show();
            $jQ('#csdoubleoptin_template_area').hide();
            $jQ('#csfinal_confirm_template_area').hide();
            $jQ('#csform_alert_message').hide();
            if (is_activated_smtp == 0) {
                //$jQ('#csform_alert_message').show();
                //$jQ('#csdisclaim_smtp').show();
                $jQ('#csdisclaim_do_template').hide();
                $jQ('#csdisclaim_confirm_template').hide();
            }
        } else {
            $jQ('#csconfirm_template_area').hide();
            $jQ('#csconfirm_sender_area').hide();
            $jQ('#csform_alert_message').hide();
        }
    });
    // click double optin
    $jQ('input[name=is_double_optin]').on('click', function() {
        var double_optin = $jQ(this).val();
        var is_activated_smtp = parseInt($jQ("#is_smtp_activated").val());
        if(double_optin == '1') {
            var selectOption = '';
            $jQ($jQ("#sibformmarkup").val()).find("input[type='email']").each(function(index,i){
                selectOption +='<option value="'+$jQ(this).attr('name')+'">'+$jQ(this).parent().children(':first').html()+'</option>'
             });
            if(selectOption==''){
               alert('Please add any email field'); 
             return false;
            }
            $jQ('#is_email_double_optin').html(selectOption).show(); 
            $jQ('#cstemplate_id').val('-1');
            $jQ('#is_confirm_email_no').prop("checked", true);
            $jQ('#csconfirm_template_area').hide();
            $jQ('#csconfirm_sender_area').hide();
            $jQ('#csdouble_sender_area').show();
            $jQ('#csdouble_redirect_area').show();
            $jQ('#csdoubleoptin_template_area').show();
            //$jQ('#csfinal_confirm_template_area').show();
            if (is_activated_smtp == 0) {
                //$jQ('#csform_alert_message').show();
                //$jQ('#csdisclaim_smtp').show();
                $jQ('#csdisclaim_do_template').hide();
                $jQ('#csdisclaim_confirm_template').hide();
            }
        } else {
            $jQ('#is_email_double_optin').hide(); 
            $jQ('#csdouble_sender_area').hide();
            $jQ('#csdouble_redirect_area').hide();
            $jQ('#csdoubleoptin_template_area').hide();
            //$jQ('#csform_alert_message').hide();
            $jQ('#csfinal_confirm_template_area').hide();
        }
    });
    // click redirect url
    $jQ('#is_redirect_url_click_yes').on('click', function () {
        $jQ('#cssubscrition_redirect_area').show();
    });
    $jQ('#is_redirect_url_click_no').on('click', function () {
        $jQ('#cssubscrition_redirect_area').hide();
    });
    //// refresh iframe to preview form
    $jQ('#cs-preview-form-refresh').on('click',function(){
        // ajax to update form html
        update_preview();
    });
    //// display popup when delete form
    $jQ('.cs-form-delete').on('click', function(e) {
        return confirm('Are you sure you want to delete this form?');
    });
    //// custom or theme's css
    $jQ('input[name=cscss_type]').on('change',function() {
        $jQ('#sibcssmarkup').toggle();
        update_preview();
    });
   // remove all transients
    $jQ(window).focus(function() {
        var data = {
            action: 'csremove_cache',
            security: ajax_csobject.ajax_nonce
        };
        $jQ.post(ajax_csobject.ajax_url, data,function(respond) {
            if(respond == 'success') {
                //
            }
        });
    });
    /* sync wordpress users to cirrusshield contact list */
    // sync popup
    $jQ('#cs-sync-btn').on('click', function() {
        var syncModal = $jQ('.cs-sync-modal');
        syncModal.modal();
        $jQ('#sync-failure').hide();
        // add to multilist field
        var list = $jQ('#csselect_list');
        list[0].selectedIndex = 0;
        list.chosen({width:"100%"});
        syncModal.on('hidden.bs.modal', function () {
            //window.location.reload();
        });
    });
    var attrFieldLine = $jQ('.sync-attr-line').html();
    // sync add attr line filed
    $jQ('.modal-body').on('click', '.sync-attr-plus', function(){
        $jQ('.sync-attr-line').append(attrFieldLine);
        $jQ('.sync-attr-dismiss').show();
    });
    // sync dismiss attr line filed
    $jQ('.modal-body').on('click', '.sync-attr-dismiss', function(){
        $jQ(this).closest('.sync-attr').remove();
        var attrCount = $jQ('.sync-attr').length;
        if(attrCount == 1) $jQ('.sync-attr-dismiss').hide();
    });
    // set attribute matching
    $jQ('.modal-body').on('change', 'select', function () {
        if($jQ(this).attr("class") == 'sync-wp-attr'){
            $jQ(this).closest('.sync-attr').find('.sync-match').val($jQ(this).val());
        }else{
            $jQ(this).closest('.sync-attr').find('.sync-match').attr('name',$jQ(this).val());
        }
    });
    // sync users to cirrusshield
    $jQ('#cssync_users_btn').on('click', function(){
        $jQ(this).attr('disabled', 'true');
        var postData = $jQ('#cs-sync-form').serializeObject();
        $jQ(this).closest('form').find('input[type=hidden]').each(function (index, value) {
            var attrName = $jQ(this).attr('name');
            if($jQ('input[name='+attrName+']').length > 1){
                // the attribute is duplicated !
                postData['errAttr'] = attrName;
            }
        });
        var data = {
            action:'cssync_users',
            data: postData,
            security: ajax_csobject.ajax_nonce
        };
        $jQ('.csalert').hide();
        $jQ(this).find('.cs-spin').show();
        $jQ.post(ajax_csobject.ajax_url, data,function(respond) {
            $jQ('.cs-spin').hide();
            $jQ('#cssync_users_btn').removeAttr('disabled');
            if(respond.code != 'success') {
                $jQ('#sync-failure').show().html(respond.message);
            } else {
                // success to sync wp users
                $jQ('.tb-close-icon').click();
                window.location.reload();
            }
        });
    });
    $jQ('.cs-add-captcha').on('click', function(){
       var add_captcha = $jQ(this).val();
        if(add_captcha == '1')
        {
            $jQ('.cs-captcha-key').show('slow');
        }
        else
        {
            $jQ('.cs-captcha-key').hide('slow');
        }
    });
    $jQ('.popover-help-form').popover({
    });
    $jQ('.cs-spin').hide();
    $jQ('body').on('click', function(e) {
        if(!$jQ(e.target).hasClass('popover-help-form')) {
            $jQ('.popover-help-form').popover('hide');
        }
    });
    $jQ('.cs-add-terms').on('click', function(){
        var add_terms = $jQ(this).val();
        if(add_terms == '1')
        {
            $jQ('.cs-terms-url').show('slow');
        }
        else
        {
            $jQ('.cs-terms-url').hide('slow');
        }
    });
    $jQ('.cs-add-to-form').on('click', function(){
        var btn_id = $jQ(this).attr('id');
        var field_html = '';
        if(btn_id == 'csadd_to_form_btn')
        {
            field_html = $jQ('#csfield_html').val();
        }
        else if(btn_id == 'csmulti_lists_add_form_btn')
        {
            field_html = $jQ('#csmulti_field_html').val();
            $jQ('#csmulti_list_field').hide();
        }
        else if(btn_id == 'csadd_captcha_btn')
        {
            var site_key = $jQ('#cscaptcha_site').val();
            var secret_key = $jQ('#cscaptcha_secret').val();
            var gCaptcha_type = $jQ('input[name=csrecaptcha_type]:checked').val();
            if(gCaptcha_type == '0')
            {
                field_html = '<div id="cscaptcha"></div>';
            }
            if(site_key == '')
            {
                $jQ('#csform_captcha .alert-danger').html('You should input <strong>Site Key</strong>').show(300);
                return false;
            }
            else if(secret_key == '')
            {
                $jQ('#csform_captcha .alert-danger').html('You should input <strong>Secrete Key</strong>').show(300);
                return false;
            }
        }
        else if(btn_id == 'csadd_termsUrl_btn')
        {
            var terms_url = $jQ('#csterms_url').val();
            field_html = '<input type="checkbox" name="terms" required="required">I accept the <a href="' + terms_url + '">terms and conditions</a> ';
            if(terms_url == '')
            {
                $jQ('#csform_terms .alert-danger').html('You should input <strong>Terms URL</strong>').show(300);
                return false;
            }
        }
        else if(btn_id == 'csadd_compliance_note')
        {
            var compliance_note = $jQ('#csgdpr_text').val();
            field_html = '<p>' + compliance_note + '</p>';
        }
        var formMarkup = $jQ("#sibformmarkup");
        var cursorPosition = get_cursor_position(formMarkup[0]);
        var html = formMarkup.val();
        if(html.charCodeAt(cursorPosition) == 10 || html.charCodeAt(cursorPosition) == 13){ // 10 is value of new line
            field_html = "\n" + field_html;
        }else{
            field_html = field_html + "\n";
        }
        var formData = [html.slice(0, cursorPosition), field_html, html.slice(cursorPosition)].join('');
        formMarkup.val(formData);
        // hide field edit after add the field to form
        $jQ('#cs-field-content').hide();
        $jQ("#cssel_attribute").val('-1');
        /*/ refresh iframe form /*/
        // ajax to update form html
        update_preview();
        // set cursor position at top
        setSelectionRange(formMarkup[0], 0, 0);
        return false;
    });
    var redirect = '';
    $jQ('.cs-form-redirect').on('click', function(e){
        e.preventDefault();
        redirect = $jQ(this).attr('href');
        $jQ('#csmodal').modal();
    });
    $jQ('#csform_lang').on('change', function(){
        $jQ('#csmodal').modal();
    });
    $jQ('#csmodal_cancel').on('click', function(){
        $jQ('#csmodal').modal('hide');
        $jQ('#csform_lang').val("");
    });
    $jQ('#csmodal_ok').on('click', function(){
        var url = (redirect != '')? redirect :$jQ('#csform_lang').val();
        window.location.href = url;
    });
    // duplicate content from origin form in translation
    $jQ('.cs-duplicate-btn').on('click', function(){
        $jQ('.cs-spin').show();
        var pid = $jQ('input[name="pid"]').val();
        var data = {
            action: 'cscopy_origin_form',
            pid: pid,
            security: ajax_csobject.ajax_nonce
        };
        $jQ.post(ajax_csobject.ajax_url, data, function(respond) {
            $jQ('.cs-spin').hide();
            $jQ('#sibformmarkup').val(respond);
        });
    });
    $jQ('.cs-add-compliant-note').on('click', function () {
        var add_notes = $jQ(this).val();
        if(add_notes == '1')
        {
            $jQ('.cs-gdpr-block-area').show('slow');
            $jQ('.cs-gdpr-block-btn').show('slow');
        }
        else
        {
            $jQ('.cs-gdpr-block-area').hide('slow');
            $jQ('.cs-gdpr-block-btn').hide('slow');
        }
    });
    $jQ('#set_gdpr_default').on('click', function () {
        $jQ('#csgdpr_text').val(ajax_csobject.compliance_note);
    })
});
// get serialized data form sync users form
$jQ.fn.serializeObject = function()
{
    var o = {};
    var a = this.serializeArray();
    $jQ.each(a, function() {
        if (o[this.name] !== undefined) {
            if (!o[this.name].push) {
                o[this.name] = [o[this.name]];
            }
            o[this.name].push(this.value || '');
        } else {
            o[this.name] = this.value || '';
        }
    });
    return o;
};